/*****************************************************************************
	Ball: Buster
	Copyright (C) 2004 PatrickAvella

    This file is part of Ball: Buster.

    Ball: Buster is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ball: Buster is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Ball: Buster; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************
**  Ball: Buster uses the ClanLib sdk, it can be found at http://clanlib.org
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
*******************************************************************************/


#include "CImage.h"

void CImage::load()
{

	this->leftborder= new CL_Surface(DATADIR "imgs/leftborder.png");
	this->rightborder= new CL_Surface(DATADIR "imgs/rightborder.png");
	this->topborder= new CL_Surface(DATADIR "imgs/topborder.png");
	this->bgtile= new CL_Surface(DATADIR "imgs/bg1.jpg");

	CL_ResourceManager spritesSrc(DATADIR "imgs/sprites.scr", false);

	this->ball = new CL_Sprite("ball", &spritesSrc);
	this->fireball= new CL_Sprite("fireball", &spritesSrc);

	this->paddle= new CL_Sprite("default_paddle", &spritesSrc);
	this->paddle->set_play_loop(true);
	this->smallpaddle= new CL_Sprite("small_paddle", &spritesSrc);
	this->smallpaddle->set_play_loop(true);
	this->largepaddle= new CL_Sprite("large_paddle", &spritesSrc);
	this->largepaddle->set_play_loop(true);

	this->rblock= new CL_Sprite("block", &spritesSrc);
	this->rblock->set_play_loop(true);
	this->rblock->set_frame_delay(0, 20.0f);
	this->rblock->set_color(1.0f, 0.0f, 0.0f, 1.0f);

	this->rblockpart= new CL_Sprite("block_part", &spritesSrc);
	this->rblockpart->set_play_loop(true);
	this->rblockpart->set_color(1.0f, 0.0f, 0.0f, 1.0f);

	this->gblock= new CL_Sprite("block", &spritesSrc);
	this->gblock->set_play_loop(true);
	this->gblock->set_frame_delay(0, 20.0f);
	this->gblock->set_color(0.0f, 1.0f, 0.0f, 1.0f);

	this->gblockpart= new CL_Sprite("block_part", &spritesSrc);
	this->gblockpart->set_play_loop(true);
	this->gblockpart->set_color(0.0f, 1.0f, 0.0f, 1.0f);


	this->bblock= new CL_Sprite("block", &spritesSrc);
	this->bblock->set_play_loop(true);
	this->bblock->set_frame_delay(0, 20.0f);
	this->bblock->set_color(0.0f, 0.0f, 1.0f, 1.0f);

	this->bblockpart= new CL_Sprite("block_part", &spritesSrc);
	this->bblockpart->set_play_loop(true);
	this->bblockpart->set_color(0.0f, 0.0f, 1.0f, 1.0f);

	this->yblock= new CL_Sprite("block", &spritesSrc);
	this->yblock->set_play_loop(true);
	this->yblock->set_frame_delay(0, 20.0f);
	this->yblock->set_color(1.0f, 1.0f, 0.0f, 1.0f);

	this->yblockpart= new CL_Sprite("block_part", &spritesSrc);
	this->yblockpart->set_play_loop(true);
	this->yblockpart->set_color(1.0f, 1.0f, 0.0f, 1.0f);

	this->tblock= new CL_Sprite("block", &spritesSrc);
	this->tblock->set_play_loop(true);
	this->tblock->set_frame_delay(0, 20.0f);
	this->tblock->set_color(0.0f, 0.8f, 1.0f, 1.0f);

	this->tblockpart= new CL_Sprite("block_part", &spritesSrc);
	this->tblockpart->set_play_loop(true);
	this->tblockpart->set_color(0.0f, 0.8f, 1.0f, 1.0f);

	this->wblock= new CL_Sprite("block", &spritesSrc);
	this->wblock->set_play_loop(true);
	this->wblock->set_frame_delay(0, 20.0f);
	this->wblock->set_color(1.0f, 1.0f, 1.0f, 1.0f);

	this->wblockpart= new CL_Sprite("block_part", &spritesSrc);
	this->wblockpart->set_play_loop(true);
	this->wblockpart->set_color(1.0f, 1.0f, 1.0f, 1.0f);

	this->cblock= new CL_Sprite("cblock", &spritesSrc);
	this->cblockpart= new CL_Sprite("cblockpart", &spritesSrc);
	this->sblock= new CL_Sprite("sblock", &spritesSrc);
	this->sblockpart= new CL_Sprite("sblockpart", &spritesSrc);

	this->flash= new CL_Sprite("flash", &spritesSrc);
	this->crack= new CL_Sprite("crack", &spritesSrc);

//	CL_Sprite *pupaddleregular, *pupaddlesmall, *pupaddlelarge, *pufastball, *puslowball, *puregularspeed,
//		*pumultiball, *pu1up, *publaster, *pufireball;	
	this->pupaddleregular= new CL_Sprite("pupaddleregular", &spritesSrc);
	this->pupaddlesmall= new CL_Sprite("pupaddlesmall", &spritesSrc);
	this->pupaddlelarge= new CL_Sprite("pupaddlelarge", &spritesSrc);
	this->publaster= new CL_Sprite("publaster", &spritesSrc);
	this->pufastball= new CL_Sprite("pufastball", &spritesSrc);
	this->pufireball= new CL_Sprite("pufireball", &spritesSrc);
	this->pumultiball= new CL_Sprite("pumultiball", &spritesSrc);
	this->puregularspeed= new CL_Sprite("puregularspeed", &spritesSrc);
	this->puslowball= new CL_Sprite("puslowball", &spritesSrc);
	this->pu1up= new CL_Sprite("pu1up", &spritesSrc);
	this->pusticky= new CL_Sprite("pusticky", &spritesSrc);
	this->pusupersticky= new CL_Sprite("pusupersticky", &spritesSrc);
	this->pureset= new CL_Sprite("pureset", &spritesSrc);
	this->purandom = new CL_Sprite("purandom", &spritesSrc);
	this->pu100 = new CL_Sprite("pu100", &spritesSrc);
	this->pu250 = new CL_Sprite("pu250", &spritesSrc);
	this->pu500 = new CL_Sprite("pu500", &spritesSrc);
	this->pu1000 = new CL_Sprite("pu1000", &spritesSrc);
	this->pucatchblue = new CL_Sprite("pucatchblue", &spritesSrc);
	this->pucatchred = new CL_Sprite("pucatchred", &spritesSrc);

	this->arrow= new CL_Sprite("arrow", &spritesSrc);
	this->bblogo= new CL_Sprite("bblogo", &spritesSrc);
	this->palogo= new CL_Sprite("palogo", &spritesSrc);
	this->xlogo = new CL_Sprite("xlogo", &spritesSrc);

	CL_ResourceManager resources(DATADIR "imgs/font.xml");
	this->font= new CL_Font("Font2", &resources);
	this->font->set_color(1.0f, 1.0f, 1.0f, 1.0f);

}


void CImage::unload() {
	delete this->ball;
	delete this->fireball;
	delete this->leftborder;
	delete this->rightborder;
	delete this->topborder;
	delete this->bgtile;

	delete this->paddle;
	delete this->largepaddle;
	delete this->smallpaddle;
	delete this->rblock;
	delete this->rblockpart;
	delete this->gblock;
	delete this->gblockpart;
	delete this->bblock;
	delete this->bblockpart;
	delete this->yblock;
	delete this->yblockpart;
	delete this->tblock;
	delete this->tblockpart;
	delete this->wblock;
	delete this->wblockpart;
	delete this->cblock;
	delete this->cblockpart;		
	delete this->sblock;
	delete this->sblockpart;
	
	delete this->flash;

	delete this->pupaddleregular;
	delete this->pupaddlesmall;
	delete this->pupaddlelarge;
	delete this->publaster;
	delete this->pufastball;
	delete this->pufireball;
	delete this->pumultiball;
	delete this->puregularspeed;
	delete this->puslowball;
	delete this->pu1up;
	delete this->pusticky;
	delete this->pureset;
	delete this->purandom;
	delete this->pu100;
	delete this->pu250;
	delete this->pu500;
	delete this->pu1000;
	delete this->pucatchblue;
	delete this->pucatchred;

	delete this->arrow;
	delete this->bblogo;
	delete this->palogo;
	delete this->xlogo;


	delete this->font;
	}


