/*****************************************************************************
	Ball: Buster
	Copyright (C) 2004 PatrickAvella

    This file is part of Ball: Buster.

    Ball: Buster is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ball: Buster is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Ball: Buster; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************
**  Ball: Buster uses the ClanLib sdk, it can be found at http://clanlib.org
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
*******************************************************************************/

#include "block.h"

CBlock::CBlock() {

	x = y = 0.0f;
	w = 40.0f; 
	h = 20.0f;

	this->str= 1;

	this->power= "";

	this->block= 0;

	this->type= 'g';

	}

CBlock::~CBlock() {
	this->block= 0;
	}

bool CBlock::collision(float myx, float myy, float myw, float myh) {

	if ( myx + myw < x ) return false;
	if ( myx > x + w   ) return false;
	if ( myy + myh < y ) return false;
	if ( myy > y + h   ) return false;

	return true;

	}

float CBlock::crackPercentage()
{
	// I want a function that is linear, and it returns 
	//		0 when str = originalStr
	//		1 when str = 1
	// varies linearly with str in between
	// it would be easier with another variable, altstr = str - 1
	int altstr = str - 1;

	// slope of something like that: 
	//		rise = -1
	//		run = originalstr - 1
	//		intercept = 1
	
	float retVal = -1/(originalStr - 1.0f) * altstr + 1.0f;

	return retVal;
}
