/*****************************************************************************
	Ball: Buster
	Copyright (C) 2004 PatrickAvella

    This file is part of Ball: Buster.

    Ball: Buster is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ball: Buster is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Ball: Buster; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************
**  Ball: Buster uses the ClanLib sdk, it can be found at http://clanlib.org
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
*******************************************************************************/

#include "headers.h"

class CBlock {
private:
	float x, y, w, h;
	
	int str;
	int originalStr;


public:
	CL_Sprite *block, *blockpart;
	
	CBlock();
	~CBlock();

	bool collision(float, float, float, float); // x y w h return s for side or t for top

	char type; // g for glass, s for stone used for break noise, i for invincible.
	
	int getStr() { return str; } 
	void setStr(int strength) { originalStr = str = strength; }

	void decreaseStr(int amount = 1) { str -= amount; }

	void setCoords(float myx, float myy) { x= myx; y= myy; }

	float getx() { return x; }
	float gety() { return y; }

	float crackPercentage();		// percentage of crack overlay to show

	string power, color;

	};
