/*****************************************************************************
	Ball: Buster
	Copyright (C) 2004 PatrickAvella

    This file is part of Ball: Buster.

    Ball: Buster is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Ball: Buster is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Ball: Buster; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*******************************************************************************
**  Ball: Buster uses the ClanLib sdk, it can be found at http://clanlib.org
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
*******************************************************************************/

#include "headers.h"

enum ePowerups
{
	ONEUP = 'a',
	BLASTER = 'b',
	FASTBALL = 'c',
	FIREBALL = 'd',
	MULTIBALL = 'e',
	LARGEPADDLE = 'f',
	REGULARPADDLE = 'g',
	SMALLPADDLE = 'h',
	NORMALSPEED = 'i',
	SLOWBALL = 'j',
	STICKY = 'k',
	RESET = 'l',
	PTS100 = 'm',
	PTS250 = 'n',
	PTS500 = 'o',
	PTS1000 = 'p',
	RANDOM = 'r',
	CATCHBLUE = 's',
	CATCHRED = 't',
	SUPERSTICKY = 'u',

	PU_NONE = 'z'
};


class CPowerUp 
{
public:
	int start;
	int delay;
	float w, h;
	float r, g, b, a;
	float x, y, vx, vy;
	float extray;
	
	CL_Sprite *icon;

	CPowerUp(float myx, float myy);
	
	virtual bool update(int myfps);

	void setEffect(ePowerups effect);
	char getEffect();
	
	bool isRed()  { return isred; }
	bool isBlue() { return isblue; }

	ePowerups oldeffect;

private:
	ePowerups effect;
	bool isred, isblue;
};



class CPowerUpList
{
public:
	CPowerUpList();
	~CPowerUpList();

	void clear();
	void addEffect(ePowerups effect, CL_Sprite *icon, int weight);
	void removeEffect(ePowerups effect);

	void AssignPowerup(CPowerUp **powerup, float x, float y);

private:
	class PUData
	{
	public:
		PUData(ePowerups myeffect, CL_Sprite *myicon, int myweight) : 
		  effect(myeffect), icon(myicon), weight(myweight) {}
		
		ePowerups effect;
		CL_Sprite *icon;
		int weight;

	};

	vector<PUData*> data;

	int total;
};

